<%--
 * Component: qc
 *
 * Description:
 * 	Merges (match and correct) a study to an order
 *
 * Parameters:
 *
 * @param cStudy        Study Instance UID of the study to be matched
 * @param cOrder        Study Instance UID of the order to be matched
 *	@param cBack         URL to go back after matching the study to the order
 * @param cMoreBack     URL to get back to select another study for the order
 *                      (correction / more studies page)
 *	@param cApply        Apply the match with the selected values
 *
 *  Last Updated     : $Author$
 *  Update Date Time : $Date$
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page import="imagemed.dcprocessing.*, imagemed.util.*, imagemed.tables.*, imagemed.exception.*,
			imagemed.jsputil.*, imagemed.imtables.*, imagemed.imsession.*, java.util.*, java.io.*, java.sql.*, imagemed.dotcom.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	String parIface = request.getParameter( "cIface" );
	boolean isIface = false;
	String tabPage = "qc/index.jsp";

	if ( "tabs".equals( parIface ) ) {
		// show tabs for page called via HTTP API
		isIface = true;
	}
	else if ( "true".equals( parIface ) ) {
		// hide tabs for page called via HTTP API
		isIface = true;
		tabPage = null;		
	}
	
	String thisPage = "/qc/confirm.jsp";

	String parStudy = request.getParameter( "cStudy" );
	String parOrder = request.getParameter( "cOrder" );

	// Back URL
	String parBack = request.getParameter( "cBack" );
	String parMoreBack = request.getParameter( "cMoreBack" );

	if ( !isIface ) {
		if ( parBack == null ) {
			parBack = request.getHeader( "REFERER" );
		}
		if ( parBack == null ) {
			is.regDest = is.httpx_host + "/qc/index.jsp";
		}
	}

	String indexBack = parBack;
	String moreBack = parMoreBack;
	if ( moreBack == null )
		moreBack = indexBack;

	// In case of timeout go back to index.jsp
	is.regDest = request.getParameter( "reg_dest" );
	if ( is.regDest == null )
		is.regDest = parBack;

	if ( !is.regOK() ) {
		return;
	}

	
	if ( parStudy == null || parOrder == null ) {
		throw new IMCommonGUIException( is, LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ) , tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_ERROR_TITLE" ), parBack, 0 );
	}

	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/qc/confirm.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect( redirURL );
		return;
	}
	
	boolean doChanges = "true".equals( request.getParameter( "cApply" ) );

	Syslog logger = new Syslog( "merge", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );

	
%><%!

	String mergeFields[] = { "PAID", "PANM", "PDOB", "PSEX", "ACCN", "PRST", "MODA",
			"PHRF", "PHRD", "PHPR", "PHRR", "BDYP", "DSCR", "INSN" };

	TableProperties tp = new TableProperties();

	WorklistResult createWorklistResult( String study, IMFieldManager fm, String fields[], IMSession is ) {
		TableDescriptor desc = new TableDescriptor();
		WorklistTableParams params = new WorklistTableParams( is.imRequest, is.regID );
		params.setDefaultFields( fields );

		if ( study != null ) {
			Properties filters = new Properties();
			filters.setProperty( "SYUI", study );
			params.setDefaultFilters( filters );
		}

		desc.setTableParams( params );
		desc.setFieldManager( fm );

		return new WorklistResult( is, desc );
	}

	Set<String> readReportTagConfig() {
		Set<String> set = new HashSet<String>();
		try {
			String fileName = IMEnvBase.getEnv( "QC_VAR" ) + "/reporttag.cfg";
			BufferedReader br = new BufferedReader( new FileReader( fileName ) );
			String line = null;
			while ( null != ( line = br.readLine() ) ) {
				if ( line.startsWith( "(" ) ) {
					try {
						set.add( line.substring( 1, 10 ) );
					}
					catch ( Throwable th0 ) {
					}
				}
			}
			br.close();
		}
		catch ( Throwable th ) {
		}

		return set;
	}

	boolean isInSet( String tag, Set<String> set ) {
		int pos = tag.indexOf( "_" );
		if ( pos == -1 )
			return set.contains( tag );
		return set.contains( tag.substring( pos ) );
	}

	String getRadioButton( String field, String value, boolean checked ) {
		return "<input type=\"radio\" name=\"r_" + field + "\" value=\"" +
				Helper.htmlEncode( value ) + "\"" + ( checked ? " checked" : "" ) + ">";
	}

	void printHiddenField( JspWriter out, String prefix, String field, String value ) throws IOException {
		out.print( "<input type=\"hidden\" name=\"" + prefix + "_" + field + "\" value=\"" );
		out.println( Helper.htmlEncode( value ) + "\">" );
	}

	void addDeleteModTag( String field, IMFieldManager fm, IMProperties prp ) {
		try {
			String tag = fm.getDicomTag( field );
			int pos = tag.indexOf( "_" );
			if ( pos == -1 ) {
				prp.setProperty( "d(" + tag + ")", "--" );
				return;
			}

			StringTokenizer stTag = new StringTokenizer( tag, "_" );

			while ( stTag.hasMoreTokens() ) {
				String t = stTag.nextToken();
				prp.setProperty( "d(" + t + ")", "--" );
			}
		}
		catch ( Throwable th ) {
		}
	}


	void addModTag( String field, String value, IMFieldManager fm, IMProperties prp ) {
		if ( value == null )
			return;

		try {
			String tag = fm.getDicomTag( field );
			int pos = tag.indexOf( "_" );
			if ( pos == -1 ) {
				prp.setProperty( "h(" + tag + ")", value );
				return;
			}

			StringTokenizer stTag = new StringTokenizer( tag, "_" );
			StringTokenizer stVal = new StringTokenizer( value, "_" );

			while ( stTag.hasMoreTokens() ) {
				String t = stTag.nextToken();
				String v = stVal.nextToken();
				prp.setProperty( "h(" + t + ")", v );
			}
		}
		catch ( Throwable th ) {
		}
	}

%><%

	String tables[] = { IMEnvBase.getEnv( "STUDYTBL" ), IMEnvBase.getEnv( "OBJECTTBL" ) };
	IMFieldManager fm = new IMFieldManager( IMEnvBase.getEnv( "FIELDSTBL" ), IMEnvBase.getEnv( "TYPESTBL" ), tables );

	String fields[] = mergeFields;
	Set<String> set = readReportTagConfig();

	// Apply merge

	if ( doChanges ) {
		Vector<String> hardMergeVector = new Vector<String>();
		Vector<String> softMergeVector = new Vector<String>();
		IMProperties editMod = new IMProperties();

		for ( int i = 0; i < fields.length; i++ ) {
			String fType = request.getParameter( "r_" + fields[ i ] );

			if ( "ORDER".equals( fType ) ) {
				// Add to Hard Merge
				hardMergeVector.add( fields[ i ] );
			}
			else if ( "EDIT".equals( fType ) ) {
				// Add to Edit MOD
				String value = fm.convertInputField( request, fields[ i ] );
				addModTag( fields[ i ], value, fm, editMod );
			}
			else if ( "STUDY".equals( fType ) ) {
				// STUDY field
				if ( isInSet( fm.getDicomTag( fields[ i ] ), set ) )
					addDeleteModTag( fields[ i ], fm, editMod );
			}
			else {
				// Soft Merge
				softMergeVector.add( fields[ i ] );
			}
		}

		String hardMergeFields[] = null;
		String softMergeFields[] = null;
		if ( !hardMergeVector.isEmpty() )
			hardMergeFields = hardMergeVector.toArray( new String[ 0 ] );
		if ( !softMergeVector.isEmpty() )
			softMergeFields = softMergeVector.toArray( new String[ 0 ] );

		Merge merger = new Merge( hardMergeFields, softMergeFields );

		String orderNum = null;
		ResultSet rs = IMEnv.getDB().prepareStatement( "select ORDERNUM from " + IMEnvBase.getEnv( "STUDYTBL" )+ " where STYIUID='" + parOrder + "'"  ).executeQuery();
		if ( rs.next() ) {
			orderNum = rs.getString( "ORDERNUM" );
		}
		rs.close();
		
		Vector<Merge.Order> orders = new Vector<Merge.Order>();
		orders.add( new Merge.Order( parOrder, orderNum ) );
		if ( !merger.mergeStudies( parStudy, orders, fm, logger, editMod, is ) )
			throw new IMCommonGUIException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_MERGING_STUDY_TO_ORDER" ),
					tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_ERROR_TITLE" ), parBack, 0 );

		response.sendRedirect( indexBack );
		return;
	}
	
%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "OPER_MERGE" ) %></TITLE>
<%
	TabToolbox.writeIMpopup( out );
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
%>
</HEAD>
<BODY><CENTER>
<%
	if ( tabPage != null ) {
		TabToolbox.makeTabs( is, is.tabbean, tabPage, "White" );
	}

	Merge merge = new Merge();

	WorklistResult resultStudy = createWorklistResult( parStudy, fm, fields, is );
	WorklistResult resultOrder = createWorklistResult( parOrder, fm, fields, is );
	if ( !resultStudy.next() || !resultOrder.next() )
		throw new IMCommonGUIException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_READING_STUDY_ORDER" ), tabPage,
				LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_ERROR_TITLE" ), parBack, 0 );

	String colShadow = tp.getColor( "StudyRowShadow" );
	Properties inputExtra = new Properties();
	inputExtra.setProperty( "EmptyInit", "true" );

	String formAction = thisPage;
	
	DualPropsConfigReader mergeMiscCfg = new DualPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/mergemisc.conf", IMEnvBase.getEnv( "CASES_HOME" ) + "/cfg/mergemisc.conf" );
	Properties mergeProps = mergeMiscCfg.getProperties();
	String showFree = mergeProps.getProperty( "showfree", "yes" );
	boolean isShowFree = "yes".equals( showFree ); 
	
%>
<FORM ACTION="<%=formAction%>" NAME="confirmForm" METHOD=POST>
<TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
<%

	String header = LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" ) + "," + LocalizedMessage.getSimpleMessage( "QC_CONFIRM_ORDER_VALUE" ) + "," + LocalizedMessage.getSimpleMessage( "QC_CONFIRM_STUDY_VALUE" );
	if( isShowFree ) {
		header += "," + LocalizedMessage.getSimpleMessage( "QC_CONFIRM_NEW_VALUE" );
	}
	out.write( Helper.header3D(  header ) );

	for ( int i = 0; i < fields.length; i++ ) {
		String tag = fm.getDicomTag( fields[ i ] );
		if ( tag == null || "".equals( tag ) || "_".equals( tag ) )
			continue;

		boolean rTag = isInSet( tag, set );

		String studyVal = resultStudy.getValue( fields[ i ], "" );
		String orderVal = resultOrder.getValue( fields[ i ], "" );
		String studyDVal = fm.display( studyVal, fields[ i ], null, null, is );
		String orderDVal = fm.display( orderVal, fields[ i ], null, null, is );

		boolean canEdit = true;
		boolean studyDefault = true;
		boolean sameValue = orderVal.equals( studyVal );

		if ( merge.isSoftField( fields[ i ] ) ) {
			canEdit = false;
			studyDefault = false;
		}
		else if ( merge.isHardField( fields[ i ] ) || rTag ) {
			studyDefault = false;
		}

		if ( canEdit ) {
			printHiddenField( out, "sv", fields[ i ], studyVal );
			if ( !sameValue )
				printHiddenField( out, "ov", fields[ i ], orderVal );
%>
	<TR><TD class=BgShadow><%=fm.getHeaderName( fields[ i ] )%></TD>
<%
			if ( sameValue ) {
%>
		<TD class=BgShadow colspan=2><%=getRadioButton( fields[ i ], "STUDY", true )
		%> <%=studyDVal%></TD>
<%
			}
			else {
%>
	<TD class=BgShadow><%=getRadioButton( fields[ i ], "ORDER", !studyDefault )
	%> <%=orderDVal%></TD>
	<TD class=BgShadow><%=getRadioButton( fields[ i ], "STUDY", studyDefault )
	%> <%=studyDVal%></TD>
<%
			}
			if( isShowFree ) {
%>
	<TD class=BgShadow nowrap><%=getRadioButton( fields[ i ], "EDIT", false )
	%> <% fm.inputField( is, fields[ i ], "", inputExtra ); %></TD>
<%
			}
%>	
	</TR>
<%
		}
		else {// can't edit
%>
	<TR><TD class=BgShadow><%=fm.getHeaderName( fields[ i ] )%></TD>
<%
			if ( sameValue ) {
%>
	<TD class=BgShadow colspan=2>&nbsp;&nbsp;<%=orderDVal%></TD>
<%
			}
			else {
%>
	<TD class=BgShadow>&nbsp;&nbsp;<%=orderDVal%></TD>
	<TD class=BgShadow>&nbsp;&nbsp;<span class=FontDisabled><%=studyDVal%></span></TD>
<%
			}
			if( isShowFree ) {
%>
	<TD class=BgShadow nowrap>&nbsp;</TD>
<%
			}
%>
	</TR>
<%
		}
	}
	if ( !formAction.equals( thisPage ) ) {
%>
	<input type=hidden name=ParentSession value="<%=is._sid%>">
	<input type=hidden name=RefererHost value="<%=is.httpx_host%>">
<%
	}
	
	if ( indexBack != null ) {
%>
	<input type=hidden name=cBack value="<%=Helper.htmlEncode( indexBack )%>">
<%
	}
	
	if ( isIface ) {
%>
		<input type=hidden name=cIface value="<%= parIface %>">
<%
	}
%>
	<input type=hidden name=cApply value=true>
	<input type=hidden name=cOrder value="<%=parOrder%>">
	<input type=hidden name=cStudy value="<%=parStudy%>">
	<TR><TD colspan=4 class=BgShadow align=right><BR>
	<A href="javascript:self.document.confirmForm.submit();"
	onMouseOver="window.status='Apply Merge'; return true;"
	><IMG src="/cases/art/apply.gif" border=0 alt="<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_APPLY_MERGE" ) %>" title="<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_APPLY_MERGE" ) %>"></a>
	&nbsp; &nbsp; &nbsp; &nbsp;
	
<%
	if ( moreBack != null ) {
%>
	<A href="<%=moreBack%>" onMouseOver="window.status='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_CANCEL" ) %>'; return true;"
	><IMG src="/cases/art/cancel.gif" border=0 alt="<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_CANCEL" ) %>" title="<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_CANCEL" ) %>"></a>
	&nbsp; &nbsp; &nbsp; &nbsp;
<%
	}
%>
	</TD></TR>
	<TR><TD colspan=4 class=FieldBlock></td>
</tr>
</TABLE></FORM></BODY></HTML>